;-----------------------------------------------------------------------------------------------
;By Marc Plouhinec (URL: http://www.thebestof.tk email:m_plouhinec@yahoo.fr)
;Small program that explains how to use the interrupts
;This program displays 2 characters, one is always changed and one is alwys the same
;If [1] is hit, both characters are changing, and if [2] is hit, the program quits.
;This software is an exemple for SNG programmers
; translated by pacHa
;-----------------------------------------------------------------------------------------------

#include "sngbeta.inc"
 .ORG START_ADDR
 .DB "Example : interrupts",0

 ROM_CALL(CLEARLCD)      ;Clear the screen

 LD DE,test              ;Load the first interrupt
 CALL NEW_INTERRUPT      ;

boucle1:                 ;
 CALL affiche_caractere  ;
 ld      a,$FF           ;
 out     (1),a           ;Wait for [1]
 ld      a,%11101111     ;
 out     (1),a           ;
 in      a,(1)           ;
 and     %00000010       ;
 jr      nz,boucle1      ;

 LD DE,test2             ;Load the second interrupt
 CALL NEW_INTERRUPT      ;

boucle2:                 ;
 CALL affiche_caractere  ;
 ld      a,$FF           ;
 out     (1),a           ;Wait for [2]
 ld      a,%11110111     ;
 out     (1),a           ;
 in      a,(1)           ;
 and     %00000010       ;
 jr      nz,boucle2      ;

 LD A,1                  ;-|Stop the 2nd interrupt
 CALL STOP_INTERRUPT     ;-|
 LD A,0                  ;---|Stop the 1st interrupt
 CALL STOP_INTERRUPT     ;---|
 RET                     ;Quit

affiche_caractere: ;draws the characters saved in buffer1 and buffer2.
 LD HL,0
 LD (CURSOR_POS),HL
 LD A,(buffer1)
 ROM_CALL(TX_CHARPUT)
 LD HL,$4
 LD (CURSOR_POS),HL
 LD A,(buffer2)
 ROM_CALL(TX_CHARPUT)
 RET

test: ;increase buffer1
 LD A,(buffer1)
 INC A
 LD (buffer1),A
 RET

test2: ;increase buffer2
 LD A,(buffer2)
 INC A
 LD (buffer2),A
 RET

buffer1 .DB 0
buffer2 .DB 0

.end
END